let parse filename lexbuf lexbuf' =
  lexbuf'.Lexing.lex_curr_p <- {
    Lexing.pos_fname = filename;
    pos_lnum = 1;
    pos_bol = 0;
    pos_cnum = 0;
  };
  let stack = ref [] in
  let get_lexer lexbuf' =
    let lexer =
      match !stack with
        | (_, _, Lexer.Lex lexer) :: _ -> lexer
        | [] -> Lexer.main in
    lexer stack lexbuf' lexbuf in
  let ast = Parser.main get_lexer lexbuf' in
  begin
    match !stack with
      | [] -> ()
      | (symbol, pos, _) :: _ -> Err.unmatched_delimiter pos symbol
  end;
  ast

let parse_chan filename chan =
  let lexbuf = Ulexing.from_utf8_channel chan in
  let lexbuf' = Lexing.from_channel chan in
  parse filename lexbuf lexbuf'

let parse_stream filename stream =
  let lexbuf = Ulexing.from_utf8_stream stream in
  let f _ _ = 0 in
  let lexbuf' = Lexing.from_function f in
  parse filename lexbuf lexbuf'
